/*****************************************************************************
 * File:         iwindow.h                                                   *
 * Version:      4.0                                                         *
 * Description:  base window class for user interface                        *
 * Authors:      Tony Prescott and Fernando Montes                           *
 * Modified:     T.J.Prescott@shef.ac.uk                                     *
 *****************************************************************************/

#ifndef IWINDOW
#define IWINDOW
 
#include <gui.h>

// iwindow class
// attributes are a gui_window (aWindow) initialised to NULL
// and a window-exists flag (aExists) initialised to 0 

class iwindow
{
 protected:
  gui_window aWindow;
  gui_rectangle aWindow_frame;
  int           aWindow_clock;
  int        aExists;
 public:
  virtual ~iwindow() {}
  virtual char* name() { return "iwindow"; }
  int exists() { return aExists; }
  uint32 get_behav_color(int);
  iwindow()
  {
    aWindow= NULL;
    aWindow_frame= NULL;
    aWindow_clock= 0;
    aExists= 0;
  }
  void clear()
    {
      if (aExists && aWindow_frame != NULL) 
	gui_rectangle_show(aWindow_frame);
      aWindow_clock= 0;
    }
};

int lbn= -2;

inline uint32 iwindow::get_behav_color(int bn)
{
  const int n_colors= 7;
  const uint32 s_colors[n_colors]= {GUI_WHITE, GUI_MAGENTA, GUI_RED, GUI_BLUE, 
				    GUI_CYAN, GUI_GREEN, GUI_BLACK };
  int nbn= (bn + 1) % n_colors;
  /*
  if (nbn != lbn) {
    cout << "behaviour " << bn << " color " << nbn << endl;
    lbn= nbn;
  }
  */

  return s_colors[nbn];
}

#endif




















