/*****************************************************************************
 * File:         data_log.h                                                  *
 * Version:      4.0                                                         *
 * Description:  class and methods for logging model activity                *
 * References:                                                               *
 * Authors:      Tony Prescott and Fernando Montes                           *
 * Contact:      T.J.Prescott@shef.ac.uk                                     *
 *****************************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <stdio.h>

class data_log
{
 private:
  ofstream aStream;
  bool aRecord;
  int aLevel;
  string aFname;
  int aDp;
  bool aQuiet;
  bool aStart;
 public: 
  bool record_log() { return aRecord; }
  bool set_record_log(bool f) { return aRecord= f; }
  int record_level() { return aLevel; }
  int set_record_level(int l) { return aLevel= l; }
  string set_record_file(string nm) { return aFname= nm; }
  int set_record_dp(int d) { return aDp= d; }
  bool set_record_quiet(bool f) { return aQuiet= f; }
  ofstream& log_stream() { return aStream; }
  void start_log(string);
  void finish_log();
  virtual void log_header() {}
  virtual void log() {}
  data_log() :
    aRecord(false), aLevel(0), aFname(""), aDp(3), aQuiet(true), aStart(false) {}
  virtual ~data_log() { }
};


void data_log::start_log(string fname="")
{
  if (aRecord && !aStart)
    {
      if (!fname.empty()) aFname= fname;
      if (!aQuiet) cout << "Opening log file '" << aFname <<"'.\n";
      aStream.open(aFname.c_str(), ios::out|ios::trunc);
      if (aStream) {
	  aStream.setf(ios::showbase);
	  aStream.setf(ios::fixed);
	  // aStream.setf(ios::showpos);
	  aStream.precision(aDp);
	  log_header();
      }
      aStart= true;
    }
}

void data_log::finish_log()
{
  // cout << "finish log " << aRecord << " " << aStart << "\n";
  if (aRecord && aStart)
    {
      if (aStream) {
	if (!aQuiet) cout << "Closing log file '" << aFname << "'\n";
	aStream.flush(); 
	aStream.close();
      }
      aStart= false;
    }
}










